### 实验十 蓝牙

#### 蓝牙技术

蓝牙协议包括两种技术：Basic Rate(BR) 和 Low Energy(LE)。Basic Rate又包括可选的EDR（Enhanced Data Rate） 技术，以及 交替使用的（Alternate）的MAC（Media Access Control）层和PHY层扩展（简称AMP）。在蓝牙4.0及后面规格中，SIG定义了四种蓝牙技术：BR，EDR，AMP和LE ，由于LE是2010年才提出的，比较新，所以人们把之前的BR/EDR/AMP技术称之为经典蓝牙。

经典蓝牙( BT)：BR(Basic Rate): 蓝牙基础速率技术。EDR(Enhanced Data Rate) : 蓝牙增强速率技术。AMP (Alternate MAC/PHYs): 蓝牙核心系统的次要控制器,可切换的媒体访问控制器（Media Access Controller）和物理层（Physical Layer）。低功耗蓝牙 (BLE)：LE(Low Energy): 蓝牙低功耗技术。

#### 程序讲解

这里我们使用BluetoothSerial库来实现蓝牙连接的功能。

例如烧录下列代码，可以实现通过串口发送数据，再将数据通过蓝牙发送到连接设备，或者连接的设备将数据发送到蓝牙里。

![image-20221206104919959](E:\派哟项目\Hexbot项目\HEXBot_使用手册\ESP32使用手册\实验十 蓝牙\蓝牙连接.png)

这里涉及一些函数

**SerialBT.begin("ESP32");**

设置蓝牙的名称，并且对蓝牙进行初始化

**Serial.available()**

判断串口是否有数据传输

**Serial.read()**

读出串口的数据

**SerialBT.write();**

蓝牙写入数据

#### 程序源码

```
//这个例程为串口和传统蓝牙架设了一座桥梁
//同时也演示了SerialBT和普通的Serial具有一样的功能

#include "BluetoothSerial.h"

#if !defined(CONFIG_BT_ENABLED) || !defined(CONFIG_BLUEDROID_ENABLED)
#error Bluetooth is not enabled! Please run `make menuconfig` to and enable it
#endif

BluetoothSerial SerialBT;

void setup() {
  Serial.begin(115200);
  SerialBT.begin("ESP32"); //蓝牙模块名称
  Serial.println("蓝牙已启动，你可以配对了！");
}

void loop() {
  if (Serial.available()) {
    SerialBT.write(Serial.read());
    Serial.println("由SerialBT打印");
  }
  if (SerialBT.available()) {
    Serial.write(SerialBT.read());
    Serial.println("由Serial打印");
  }
  delay(20);
}
```

